package org.nakedobjects.nof.reflect.i18n;

import org.nakedobjects.nof.reflect.peer.AbstractActionPeer;
import org.nakedobjects.nof.reflect.peer.ActionPeer;


public class ActionI18n extends AbstractActionPeer {
    private final I18nManager i18nManager;

    public ActionI18n(final ActionPeer decorated, final I18nManager i18nManager) {
        super(decorated);
        this.i18nManager = i18nManager;
    }

    public String getDescription() {
        String description = i18nManager.getDescription(getIdentifier());
        if (description == null) {
            return super.getDescription();
        } else {
            return description;
        }
    }

    public String getName() {
        String name = i18nManager.getName(getIdentifier());
        if (name == null) {
            return super.getName();
        } else {
            return name;
        }
    }

    public String getHelp() {
        String help = i18nManager.getHelp(getIdentifier());
        if (help == null) {
            return super.getHelp();
        } else {
            return help;
        }
    }

    public String[] getParameterNames() {
        String originalNames[] = super.getParameterNames();
        if (originalNames == null) {
            return null;
        }
        String i18nNames[] = i18nManager.getParameterNames(getIdentifier());
        for (int i = 0; i < i18nNames.length; i++) {
            if (i18nNames[i] == null) {
                i18nNames[i] = originalNames[i];
            }
        }
        return i18nNames;
    }
}
// Copyright (c) Naked Objects Group Ltd.
