package org.nakedobjects.nof.reflect.peer;

import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.NakedObjectAction;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.util.DebugString;


public abstract class AbstractActionPeer implements ActionPeer {
    private final ActionPeer decorated;

    public AbstractActionPeer(final ActionPeer decorated) {
        this.decorated = decorated;
    }

    public boolean[] canParametersWrap() {
        return decorated.canParametersWrap();
    }

    public void debugData(final DebugString debugString) {
        decorated.debugData(debugString);
    }

    public Naked execute(final NakedReference object, final Naked[] parameters) throws ReflectiveActionException {
        return decorated.execute(object, parameters);
    }

    public String getDescription() {
        return decorated.getDescription();
    }

    public Object getExtension(final Class cls) {
        return decorated.getExtension(cls);
    }

    public Class[] getExtensions() {
        return decorated.getExtensions();
    }

    public String getHelp() {
        return decorated.getHelp();
    }

    public MemberIdentifier getIdentifier() {
        return decorated.getIdentifier();
    }

    public String getName() {
        return decorated.getName();
    }
    
    public NakedObjectSpecification getOnType() {
        return decorated.getOnType();
    }

    public int getParameterCount() {
        return decorated.getParameterCount();
    }

    public Object[] getParameterDefaults(NakedReference target) {
        return decorated.getParameterDefaults(target);
    }

    public String[] getParameterDescriptions() {
        return decorated.getParameterDescriptions();
    }

    public int[] getParameterMaxLengths() {
        return decorated.getParameterMaxLengths();
    }

    public String[] getParameterNames() {
        return decorated.getParameterNames();
    }

    public int[] getParameterNoLines() {
        return decorated.getParameterNoLines();
    }

    public Object[][] getParameterOptions(NakedReference target) {
        return decorated.getParameterOptions(target);
    }

    public NakedObjectSpecification[] getParameterTypes() {
        return decorated.getParameterTypes();
    }

    public int[] getParameterTypicalLengths() {
        return decorated.getParameterTypicalLengths();
    }

    public boolean[] getOptionalParameters() {
        return decorated.getOptionalParameters();
    }

    public NakedObjectSpecification getReturnType() {
        return decorated.getReturnType();
    }

    public NakedObjectAction.Target getTarget() {
        return decorated.getTarget();
    }

    public NakedObjectAction.Type getType() {
        return decorated.getType();
    }

    public boolean isOnInstance() {
        return decorated.isOnInstance();
    }

    public Consent isParameterSetValidImperatively(final NakedReference object, final Naked[] parameters) {
        return decorated.isParameterSetValidImperatively(object, parameters);
    }
        
    public Consent isUsable(final NakedReference target) {
        return decorated.isUsable(target);
    }

    public Consent isUsableDeclaratively() {
        return decorated.isUsableDeclaratively();
    }

    public Consent isUsableForSession(
            Session session) {
        return decorated.isUsableForSession(session);
    }

    public boolean isVisibleDeclaratively() {
        return decorated.isVisibleDeclaratively();
    }
    
    public boolean isVisibleForSession(final Session session) {
        return decorated.isVisibleForSession(session);
    }

    public boolean isVisible(final NakedReference target) {
        return decorated.isVisible(target);
    }

    public ActionParamPeer[] getParameters() {
        return decorated.getParameters();
    }


}
// Copyright (c) Naked Objects Group Ltd.
