package org.nakedobjects.nof.reflect.peer;

import org.nakedobjects.noa.adapter.NakedCollection;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.util.DebugString;


public abstract class AbstractOneToManyPeer implements OneToManyPeer {
    private final OneToManyPeer decorated;

    public AbstractOneToManyPeer(final OneToManyPeer local) {
        this.decorated = local;
    }

    public void addAssociation(final NakedObject inObject, final NakedObject associate) {
        decorated.addAssociation(inObject, associate);
    }

    public void debugData(final DebugString debugString) {
        decorated.debugData(debugString);
    }
    
    public NakedCollection getAssociations(final NakedObject inObject) {
        return decorated.getAssociations(inObject);
    }

    public String getBusinessKeyName() {
        return decorated.getBusinessKeyName();
    }
    
    public String getDescription() {
        return decorated.getDescription();
    }

    public Object getExtension(final Class cls) {
        return decorated.getExtension(cls);
    }

    public Class[] getExtensions() {
        return decorated.getExtensions();
    }

    public String getHelp() {
        return decorated.getHelp();
    }

    public MemberIdentifier getIdentifier() {
        return decorated.getIdentifier();
    }

    public String getName() {
        return decorated.getName();
    }

    public Object[] getOptions(NakedReference target) {
        return decorated.getOptions(null);
    }
    
    public NakedObjectSpecification getSpecification() {
        return decorated.getSpecification();
    }

    public void initOneToManyAssociation(final NakedObject inObject, final NakedObject[] instances) {
        decorated.initOneToManyAssociation(inObject, instances);
    }

    public Consent isAddValid(final NakedObject container, final NakedObject element) {
        return decorated.isAddValid(container, element);
    }

    public boolean isPersisted() {
        return decorated.isPersisted();
    }

    public boolean isEmpty(final NakedObject inObject) {
        return decorated.isEmpty(inObject);
    }

    public boolean isMandatory() {
        return decorated.isMandatory();
    }

    public Consent isRemoveValid(final NakedObject container, final NakedObject element) {
        return decorated.isRemoveValid(container, element);
    }
    
    public Consent isUsableDeclaratively() {
        return decorated.isUsableDeclaratively();
    }

    public Consent isUsableForSession(
            Session session) {
        return decorated.isUsableForSession(session);
    }

    public Consent isUsable(final NakedReference target) {
        return decorated.isUsable(target);
    }
    
    public boolean isVisibleDeclaratively() {
        return decorated.isVisibleDeclaratively();
    }

    public boolean isVisibleForSession(final Session session) {
        return decorated.isVisibleForSession(session);
    }

    public boolean isVisible(final NakedReference target) {
        return decorated.isVisible(target);
    }

    public void removeAllAssociations(final NakedObject inObject) {
        decorated.removeAllAssociations(inObject);
    }

    public void removeAssociation(final NakedObject inObject, final NakedObject associate) {
        decorated.removeAssociation(inObject, associate);
    }
}
// Copyright (c) Naked Objects Group Ltd.
