package org.nakedobjects.nof.reflect.peer;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.spec.NakedObjectSpecification;


/**
 * Additional reflective details about field members.
 * 
 * @see org.nakedobjects.nof.reflect.peer.MemberPeer
 */
public interface FieldPeer extends MemberPeer {

    String getBusinessKeyName();

    /**
     * Returns a list of possible references/values for this field, which the user can choose from.
     */
    public Object[] getOptions(NakedReference target);

    NakedObjectSpecification getSpecification();

    boolean isPersisted();

    boolean isEmpty(NakedObject inObject);

    /**
     * Determines if this member is not optional declaratively, is <i>not</i> annotated with
     * <tt>@Optional</tt>.
     */
    boolean isMandatory();
}
// Copyright (c) Naked Objects Group Ltd.
