package org.nakedobjects.nof.reflect.peer;

import org.nakedobjects.noa.spec.NakedObjectSpecification;


public interface MemberIdentifier extends Comparable {
    String getClassName();

    String getName();

    String[] getParameters();

    NakedObjectSpecification[] getParameterSpecifications();

    /**
     * Returns true if the member is for a field/property; false if for an action.
     */
    boolean isField();

    public static final int CLASS = 0;
    public static final int CLASS_NAME = 1;
    public static final int CLASS_NAME_PARMS = 2;
    public static final int NAME = 3;
    public static final int PARMS = 4;

    String toIdentityString(final int depth);
}
// Copyright (c) Naked Objects Group Ltd.
