package org.nakedobjects.nof.reflect.peer;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedValue;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.Formatter;


public interface ValuePeer extends FieldPeer {

    boolean canClear();

    boolean canWrap();

    void clearValue(NakedObject inObject);

    /**
     * Returns the defaults references/values to be used for this field.
     */
    public NakedValue getDefault(NakedObject target);

    Formatter getFormatter();
    
    int getMaximumLength();
    
    int getNoLines();

    int getTypicalLineLength();

    NakedValue getValue(NakedObject inObject);

    void initValue(NakedObject inObject, NakedValue val);

    boolean isOptionEnabled();

    public Consent isValueValid(final NakedObject inObject, final NakedValue value);

    void setValue(NakedObject inObject, NakedValue val);

}
// Copyright (c) Naked Objects Group Ltd.
