package org.nakedobjects.nof.reflect.perspective;

import java.util.List;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.spec.Features;
import org.nakedobjects.nof.core.context.Perspective;
import org.nakedobjects.nof.core.reflect.Veto;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.nof.reflect.peer.MemberIdentifierImpl;


class ServicesPeer extends PerspectiveCollectionPeer {

    public MemberIdentifier getIdentifier() {
        return new MemberIdentifierImpl("", "services");
    }

    protected List getList(Perspective perspective) {
        return perspective.getServices();
    }

    public String getName() {
        return "Desktop Services";
    }

    public Consent isAddValid(NakedObject inObject, NakedObject element) {
        if (!Features.isService(element.getSpecification())) {
            return new Veto("Can only add service to this list");
        } else {
            return super.isAddValid(inObject, element);
        }

    }
}

// Copyright (c) Naked Objects Group Ltd.
