package org.nakedobjects.nof.reflect.remote;

import org.nakedobjects.nof.core.util.Assert;
import org.nakedobjects.nof.reflect.peer.ActionPeer;
import org.nakedobjects.nof.reflect.peer.OneToManyPeer;
import org.nakedobjects.nof.reflect.peer.OneToOnePeer;
import org.nakedobjects.nof.reflect.peer.ReflectionPeerFactory;
import org.nakedobjects.nof.reflect.peer.ValuePeer;
import org.nakedobjects.nof.reflect.remote.data.Distribution;
import org.nakedobjects.nof.reflect.remote.data.ObjectEncoder;


public class ProxyPeerFactory implements ReflectionPeerFactory {
    private Distribution connection;
    private ObjectEncoder encoder;

    public ActionPeer createAction(final ActionPeer peer) {
        return new ProxyAction(peer, connection, encoder);
    }

    public OneToManyPeer createField(final OneToManyPeer peer) {
        return new ProxyOneToManyAssociation(peer, connection, encoder);
    }

    public OneToOnePeer createField(final OneToOnePeer peer) {
        return new ProxyOneToOneAssociation(peer, connection, encoder);
    }

    public ValuePeer createField(ValuePeer peer) {
        return new ProxyValueAssociation(peer, connection, encoder);
    }
    
    /**
     * .NET property
     * 
     * @property
     */
    public void set_Connection(final Distribution connection) {
        this.connection = connection;
    }

    /**
     * .NET property
     * 
     * @property
     */
    public void set_Encoder(final ObjectEncoder encoder) {
        this.encoder = encoder;
    }

    public void setConnection(final Distribution connection) {
        this.connection = connection;
    }

    public void setEncoder(final ObjectEncoder encoder) {
        this.encoder = encoder;
    }

    public void init() {
        Assert.assertNotNull("Connection required", connection);
        Assert.assertNotNull("Object encoder required", encoder);
    }

    public void shutdown() {}
}
// Copyright (c) Naked Objects Group Ltd.
