package org.nakedobjects.nof.reflect.security;

import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.NakedObjectAction;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.reflect.Veto;
import org.nakedobjects.nof.reflect.peer.AbstractActionPeer;
import org.nakedobjects.nof.reflect.peer.ActionPeer;


public class ActionAuthorisation extends AbstractActionPeer {
    private final AuthorisationManager authorisationManager;

    public ActionAuthorisation(final ActionPeer decorated, final AuthorisationManager authorisationManager) {
        super(decorated);
        this.authorisationManager = authorisationManager;
    }

    public boolean isVisibleForSession(final Session session) {
        if (getType() == NakedObjectAction.EXPLORATION || getType() == NakedObjectAction.DEBUG) {
            return true;
        } else {
            // TODO: think we should delegate to superclass otherwise?
            return authorisationManager.isVisible(session, getIdentifier()) /*
                                                                             * &&
                                                                             * super.isVisibleForSession(session)
                                                                             */;
        }
    }

    
    public Consent isUsableForSession(final Session session) {
        if (!authorisationManager.isEditable(session, getIdentifier())) {
            return new Veto("Not permitted to edit field");
        } else {
            return Allow.DEFAULT;
        }
    }

}
// Copyright (c) Naked Objects Group Ltd.
