package org.nakedobjects.nof.reflect.security;

import org.nakedobjects.nof.core.util.ToString;
import org.nakedobjects.nof.reflect.peer.ActionPeer;
import org.nakedobjects.nof.reflect.peer.OneToManyPeer;
import org.nakedobjects.nof.reflect.peer.OneToOnePeer;
import org.nakedobjects.nof.reflect.peer.ReflectionPeerFactory;
import org.nakedobjects.nof.reflect.peer.ValuePeer;


public class SecurityPeerFactory implements ReflectionPeerFactory {
    private AuthorisationManager manager;

    public void setAuthorisationManager(final AuthorisationManager manager) {
        this.manager = manager;
    }

    /**
     * Expose as a .NET property
     * 
     * @property
     */
    public void set_AuthorisationManager(final AuthorisationManager manager) {
        setAuthorisationManager(manager);
    }

    public ActionPeer createAction(final ActionPeer peer) {
        return new ActionAuthorisation(peer, manager);
    }

    public OneToManyPeer createField(final OneToManyPeer peer) {
        return new OneToManyAuthorisation(peer, manager);
    }

    public OneToOnePeer createField(final OneToOnePeer peer) {
        return new OneToOneAuthorisation(peer, manager);
    }

    public ValuePeer createField(final ValuePeer peer) {
        return new ValueAuthorisation(peer, manager);
    }

    public void init() {
        manager.init();
    }

    public void shutdown() {
        manager.shutdown();
    }
    
    public String toString() {
        ToString str = new ToString(this);
        str.append("manager", manager);
        return str.toString();
    }
}
// Copyright (c) Naked Objects Group Ltd.
